import java.awt.event.*;
import java.awt.*;
import java.util.*;


class MainPanel extends Panel implements ButtonsInterface, SocketCaller{

	MainPanel(){
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		addMouseMotionListener(mouseDispatcher);
		
		if (serverIP == null)
			socketThread = new ServerSocketThread(this);
		else
			socketThread = new ClientSocketThread(this, serverIP);
	}
	
	
	
	
	static String serverIP;
	public SocketThread socketThread;
	public void socketConnected(){
	}
	public void messageArrived(String str){
		receive_stroke(str);
	}		

	
	
	
	public void send_stroke(Stroke stroke){
		String line = "";
		for(int i=0; i<stroke.points.size(); i++){
			Point p = (Point) (stroke.points.elementAt(i));
			line += " "+p.x+" "+p.y;
		}
		socketThread.send(line);
	}
	public void receive_stroke(String line){
		Stroke stroke = new Stroke();
		StringTokenizer st = new StringTokenizer(line);
		while(st.hasMoreTokens()){
			int x = new Integer(st.nextToken()).intValue();
			int y = new Integer(st.nextToken()).intValue();
			stroke.addPoint(new Point(x, y));
		}
		strokes.addElement(stroke);
		repaint_all();
	}
	
	

	
	
	public void initializeButtons(Buttons buttons){
		buttons.addButton("quit");
		buttons.addButton("clear");
	}
	public void buttonPressed(String label){
		if (label.equals("quit"))
			System.exit(0);
		if (label.equals("clear"))
			clear();
	}	
	
	
	
	
	
	
	
	
	Image buffered_image = null;
	public void update(Graphics g) {
		paint(g);
	}
	public boolean repaint_all = true;
	public void repaint_all(){
		repaint_all = true;
		repaint();
	}
	public void paint(Graphics g) {

		if (repaint_all){
			//double buffering
			if (buffered_image == null)
				buffered_image = createImage(getSize().width, getSize().height);
			Graphics bg = buffered_image.getGraphics();

			// clear
			bg.setColor(Color.white);
			bg.fillRect(0,0, getSize().width, getSize().height);
			
			// paint code!
			for(int i=0; i<strokes.size(); i++){
				Stroke stroke = (Stroke) strokes.elementAt(i);
				stroke.paint(bg);
			}
			bg.setColor(Color.black);
			bg.drawString("host: "+serverIP, 10,20);

			//double buffering
			bg.dispose();
      
			g.drawImage(buffered_image,0,0,this);

			
			repaint_all = false;
		}
		else{
			// paint code!
			if (stroke !=null)
			stroke.incremental_paint(g);
		}

		
	}
	
	

   
   
	
	
	
	public void paint_stroke(Graphics g, Vector stroke){
		for(int i=0; i<stroke.size()-1; i++){
			Point p = (Point) stroke.elementAt(i);
			Point q = (Point) stroke.elementAt(i+1);
			g.drawLine(p.x, p.y, q.x, q.y);
		}
	}
	
	
	
	

	
	
	
	
	
	//
	// event handling
	//
	Vector strokes = new Vector();
	Stroke stroke = null;
	public void start_stroke(Point p){
		stroke = new Stroke();
		extend_stroke(p);
	}
	public void extend_stroke(Point p){
		stroke.addPoint(p);
		repaint();
	}
	public void finish_stroke(Point p){
		strokes.addElement(stroke);
		send_stroke(stroke);
		repaint_all();
	}
	
	
	
	
	public void clear(){
		strokes = new Vector();
		repaint_all();
	}
	
	
	
	
	
	
	

	
	
	
	
   
	
	public int operation_status;
	public static final int NONE = 0;
	public static final int DRAWING = 1;
   
	//   
	// central event dispatcher
	//
	public class MouseDispatcher 
		extends MouseAdapter implements MouseMotionListener{

  		public void mouseMoved(MouseEvent e) {
  		}
  		public void mousePressed(MouseEvent e) {
			Point p = e.getPoint();
			boolean right_button = (e.getModifiers() & e.BUTTON3_MASK) != 0;
			
			operation_status = DRAWING;
			start_stroke(p);
		}
  		public void mouseDragged(MouseEvent e) {
			Point p = e.getPoint();
			
			switch(operation_status){
			case DRAWING:
				extend_stroke(p);
				break;
			}
			
   		}
		public void mouseReleased(MouseEvent e) {
			Point p = e.getPoint();
			
			switch(operation_status){
			case DRAWING:
				finish_stroke(p);
				break;
			}
		}
		public void mouseClicked(MouseEvent e){
		}
    }
}







